SystemOrganization addCategory: #'Deltawerken-Framework'!
SystemOrganization addCategory: #'Deltawerken-Framework-Test'!

Object subclass: #DEApplicationDescription
	instanceVariableNames: 'applicationClass libraryClass domainClassDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Framework'!

DEApplicationDescription class
	instanceVariableNames: 'singleton'!

!DEApplicationDescription commentStamp: 'DiegoLont 8/27/2012 13:02' prior: 0!
DEApplicationDescription can be used to generate an application based on Deltawerken.

Use the following syntax:.
DEApplicationDescription newApplication: '<your application name>' prefix: '<your prefix>'  category: '<your category>' 

example:
	DEApplicationDescription newApplication: 'Forum Demo' prefix: 'FD' category: 'ForumDemo'

After this, you can use your application description to add model classes and fields. The name of tis description is:
	<your prefix>ApplicationDescription; a class that inherits from DEApplicationDescription (this class).

Use the following methods:
	regenerate: if something went wrong, and you want your classes to be regenerated
	addDomainClass: to add a domain class to your model. This returns the description of the domain class, that allows you to add fields to this class.
	
example:
	(FDApplicationDescription addDomainClass: 'Model')
		beRoot;
		addCollection: 'authors' of: 'Author';
		addCollection: 'questions' of: 'Question';
		addCollection: 'tags' of: 'Tag'
		!

DEApplicationDescription class
	instanceVariableNames: 'singleton'!

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 8/29/2012 10:09'!
addDomainClass: aName 
	^self singleton addDomainClass: aName.! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 13:32'!
applicationCategory
	^self category, '-Web'! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 8/27/2012 13:27'!
applicationClassName
	^self prefix, (self applicationName asIdentifier: true), 'Application'! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 13:20'!
applicationName
	^'Deltawerken'! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:20'!
domainClassCategory
	^self category, '-Model'! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:33'!
libraryClassName
	^self prefix, 'FileLibrary'! !

!DEApplicationDescription class methodsFor: 'code generation' stamp: 'DiegoLont 8/26/2012 17:29'!
newApplication: aName prefix: aPrefix category: aCategory
	| descriptionClass |
	SystemOrganization addCategory: aCategory.
	descriptionClass := (ClassBuilder new) superclass: self subclass: (aPrefix, 'ApplicationDescription') asSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: aCategory.
	descriptionClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'prefix'; lf;
		tab; nextPutAll: '^'''; nextPutAll: aPrefix; nextPut: $' ]) classified: 'accessing'.
	descriptionClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'applicationName'; lf;
		tab; nextPutAll: '^'''; nextPutAll: aName; nextPut: $' ]) classified: 'accessing'.
	descriptionClass singleton applicationClass initialize! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 13:19'!
prefix
	^'DE'! !

!DEApplicationDescription class methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:44'!
regenerate
	self singleton regenerate! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:05'!
singleton
	^singleton ifNil: [ singleton := self new ]! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/29/2012 10:32'!
addDomainClass: aName
	| classDescription |
	" check if it already exists "
	classDescription := self domainClassDescriptions detect:  [ :each |
		each domainClassName = aName ] ifNone: [ nil ].
	classDescription ifNil: [
		classDescription := self domainClassDescriptions add: (DEDomainClassDescription on: self name: aName).
		classDescription generate ].
	^classDescription! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:17'!
applicationCategory
	^self class applicationCategory! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:34'!
applicationClass
	^applicationClass ifNil: [ applicationClass := self generateApplicationClass ]! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:17'!
applicationClassName
	^self class applicationClassName! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:17'!
applicationName
	^self class applicationName! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:19'!
domainClassCategory
	^self class domainClassCategory! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:18'!
domainClassDescriptions
	^domainClassDescriptions ifNil: [ domainClassDescriptions := OrderedCollection new ]! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:57'!
generateApplicationClass
	| retVal |
	self libraryClass.
	retVal := (ClassBuilder new) superclass: WAComponent subclass: self applicationClassName asSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: self applicationCategory.
	self generateApplicationMethodsTo: retVal.
	^retVal! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/27/2012 13:26'!
generateApplicationMethodsTo: aClass
	aClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'initialize'; lf;
			tab; nextPutAll: '"Registers this application as webpage"'; lf;
			tab; nextPutAll: 'super initialize.'; lf;
			tab; nextPutAll: '(WAAdmin register: self asApplicationAt: '''; nextPutAll: self applicationName; nextPutAll: ''')'; lf;
			tab; tab; nextPutAll: 'addLibrary: JQDeploymentLibrary;'; lf;
			tab; tab; nextPutAll: 'addLibrary: JQUiDeploymentLibrary' ]) classified: 'initialization'.
	aClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'canBeRoot'; lf;
			tab; nextPutAll: '^true' ]) classified: 'testing'.
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: 'title'; lf;
			tab; nextPutAll: '^'''; nextPutAll: self applicationName; nextPut: $' ]) classified: 'accessing'.
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: 'updateRoot: anHtmlRoot'; lf;
			tab; nextPutAll: 'super updateRoot: anHtmlRoot.'; lf;
			tab; nextPutAll: 'anHtmlRoot title: self title.'; lf;
			tab; nextPutAll: 'anHtmlRoot link'; lf;
			tab; tab; nextPutAll: 'type: ''text/css'';'; lf;
			tab; tab; nextPutAll: 'beStylesheet;'; lf;
			tab; tab; nextPutAll: 'addAll;'; lf;
			tab; tab; nextPutAll: 'url: '; nextPutAll: self libraryClassName; nextPutAll: ' / ''main.css''' ]) classified: 'rendering'.
	aClass methodDict at: #renderContentOn: ifAbsent: [
		aClass compile: (String streamContents: [ :s |
			s nextPutAll: 'renderContentOn: canvas'; lf;
				tab; nextPutAll: 'canvas heading: self title.'; lf;
				tab; nextPutAll: '"Insert your custom rendering code here"' ]) classified: 'rendering' ]! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:32'!
generateLibraryClass
	| retVal |
	SystemOrganization addCategory: self applicationCategory.
	retVal := (ClassBuilder new) superclass: WAFileLibrary subclass: self libraryClassName asSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: self applicationCategory.
	self generateLibraryMethodsTo: retVal! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/27/2012 13:18'!
generateLibraryMethodsTo: aClass
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: 'mainCss'; lf;
			tab; nextPutAll: '^''''']) classified: 'css'.
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: 'selectorsToInclude'; lf;
			tab; nextPutAll: '^#(main.css)']) classified: 'accessing'! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:59'!
libraryClass
	^libraryClass ifNil: [ libraryClass := self generateLibraryClass ]! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:29'!
libraryClassName
	^self class libraryClassName! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:18'!
prefix
	^self class prefix! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:59'!
regenerate
	applicationClass := nil.
	libraryClass := nil.
	self applicationClass initialize! !

Object subclass: #DEDomainClassDescription
	instanceVariableNames: 'applicationDescription domainClassName domainClass isRoot fieldDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Framework'!

!DEDomainClassDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 8/26/2012 17:54'!
on: anApplicationDescription name: aName
	^self new
		applicationDescription: anApplicationDescription;
		domainClassName: aName;
		yourself! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/29/2012 10:57'!
addCollection: aFieldName of: aClassname
	| retVal |
	self applicationDescription addDomainClass: aClassname.
	" check if we have this fieldName "
	retVal := self fieldDescriptions detect: [ :each | each fieldName = aFieldName ] ifNone: [ nil ].
	retVal ifNil: [
		retVal := self fieldDescriptions add: (DECollectionFieldDescription on: self fieldName: aFieldName domainClassname: aClassname).
		self regenerate ].
	^retVal! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 17:53'!
applicationDescription
	^ applicationDescription! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 17:53'!
applicationDescription: anObject
	applicationDescription := anObject! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/29/2012 10:13'!
beRoot
	self isRoot ifFalse: [
		isRoot := true.
		self regenerate ]! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 13:14'!
classVariableNames
	^''! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 17:58'!
domainClass
	^ domainClass ifNil: [ domainClass := self generateDomainClass ]! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:19'!
domainClassCategory
	^self applicationDescription domainClassCategory! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:20'!
domainClassFullName
	^self prefix, self domainClassName! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 17:54'!
domainClassName
	^ domainClassName! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 17:54'!
domainClassName: anObject
	domainClassName := anObject! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/29/2012 10:20'!
fieldDescriptions
	^fieldDescriptions ifNil: [ fieldDescriptions := OrderedCollection new ]! !

!DEDomainClassDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/26/2012 17:58'!
generate
	self domainClass! !

!DEDomainClassDescription methodsFor: 'code generation' stamp: 'DiegoLont 12/14/2012 13:16'!
generateClassInstanceVariableNamesTo: aClass
	self isRoot ifTrue: [
		aClass class instanceVariableNames: 'default' ].! !

!DEDomainClassDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/29/2012 11:06'!
generateClassMethodsTo: aClass
	self isRoot ifTrue: [
		aClass class compile:  (String streamContents: [ :s |
			s nextPutAll: 'default'; lf;
				tab; nextPutAll: '^default ifNil: [ default := self new ]']) classified: 'accessing'.
		aClass class compile:  (String streamContents: [ :s |
			s nextPutAll: 'reset'; lf;
				tab; nextPutAll: 'default := nil']) classified: 'maintenance' ].
	aClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'fields'; lf;
			tab; nextPutAll: '^#( '.
		self fieldDescriptions do: [ :each | s nextPutAll: each fieldName; nextPutAll: 'Field' ] separatedBy: [ s space ].
		s nextPutAll: ' )' ]) classified: 'fields'! !

!DEDomainClassDescription methodsFor: 'code generation' stamp: 'DiegoLont 12/14/2012 13:15'!
generateDomainClass
	| retVal |
	SystemOrganization addCategory: self domainClassCategory.
	retVal := (ClassBuilder new) superclass: DEDomainObject subclass: self domainClassFullName asSymbol instanceVariableNames: self instanceVariableNames classVariableNames: self classVariableNames poolDictionaries: '' category: self domainClassCategory.
	self generateClassInstanceVariableNamesTo: retVal.
	self generateClassMethodsTo: retVal.
	self generateFieldsTo: retVal.
	^retVal! !

!DEDomainClassDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/29/2012 10:39'!
generateFieldsTo: aClass
	self fieldDescriptions do: [ :each |
		each generateTo: aClass ]! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/29/2012 10:54'!
instanceVariableNames
	^String streamContents: [ :s |
		self fieldDescriptions do: [ :each | s nextPutAll: each fieldName ] separatedBy: [ s space ] ]! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/29/2012 10:14'!
isRoot
	isRoot ifNil: [ ^false ].
	^ isRoot! !

!DEDomainClassDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:20'!
prefix
	^self applicationDescription prefix! !

!DEDomainClassDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/29/2012 10:14'!
regenerate
	domainClass := nil.
	self generate! !

Object subclass: #DEFieldDescription
	instanceVariableNames: 'domainClassDescription fieldName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Framework'!

DEFieldDescription subclass: #DECollectionFieldDescription
	instanceVariableNames: 'domainClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Framework'!

!DECollectionFieldDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 8/26/2012 18:38'!
on: aDomainclassDescription fieldName: aFieldname domainClassname: aDomainClassName 
	^(self on: aDomainclassDescription fieldName: aFieldname)
		domainClassName: aDomainClassName;
		yourself! !

!DECollectionFieldDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:39'!
domainClassName
	^ domainClassName! !

!DECollectionFieldDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:39'!
domainClassName: anObject
	domainClassName := anObject! !

!DECollectionFieldDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/29/2012 10:44'!
generateAccessorTo: aClass
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: self fieldName; lf;
			tab; nextPut: $^; nextPutAll: self fieldName; nextPutAll: ' ifNil: [ '; nextPutAll: self fieldName; nextPutAll: ' := OrderedCollection new ]' ]) classified: 'accessing'! !

!DECollectionFieldDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/29/2012 11:06'!
generateFieldTo: aClass
	aClass class compile: (String streamContents: [ :s |
		s nextPutAll: self fieldName; nextPutAll: 'Field'; lf;
			tab; nextPutAll: '^DECollectionField new'; lf;
			tab; tab; nextPutAll: 'label: '''; nextPutAll: self fieldName; nextPutAll: ''';'; lf;
			tab; tab; nextPutAll: 'accessor: #( '; nextPutAll: self fieldName; nextPutAll: ' );'; lf;
			tab; tab; nextPutAll: 'domainClass: '; nextPutAll: self prefix, self domainClassName; lf;
			tab; tab; nextPutAll: 'yourself' ]) classified: 'fields'! !

!DEFieldDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 8/26/2012 18:38'!
on: aDomainClassDescription fieldName: aFieldname 
	^self new
		domainClassDescription: aDomainClassDescription;
		fieldName: aFieldname;
		yourself! !

!DEFieldDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:33'!
domainClassDescription
	^ domainClassDescription! !

!DEFieldDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:33'!
domainClassDescription: anObject
	domainClassDescription := anObject! !

!DEFieldDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:33'!
fieldName
	^ fieldName! !

!DEFieldDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 18:33'!
fieldName: anObject
	fieldName := anObject! !

!DEFieldDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/29/2012 10:43'!
generateAccessorTo: aClass
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: self fieldName; lf;
			tab; nextPut: $^; nextPutAll: self fieldName ]) classified: 'accessing'! !

!DEFieldDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/29/2012 10:40'!
generateFieldTo: aClass
	self subclassResponsibility! !

!DEFieldDescription methodsFor: 'code generation' stamp: 'DiegoLont 8/29/2012 10:40'!
generateTo: aClass
	self generateAccessorTo: aClass.
	self generateFieldTo: aClass! !

!DEFieldDescription methodsFor: 'accessing' stamp: 'DiegoLont 8/29/2012 11:00'!
prefix
	^self domainClassDescription prefix! !

TestCase subclass: #DEApplicationDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Framework-Test'!

!DEApplicationDescriptionTest methodsFor: 'running' stamp: 'DiegoLont 8/27/2012 15:22'!
removeClass: aClassSymbol
	| classToRemove |
	classToRemove := Smalltalk at: aClassSymbol ifAbsent: [ nil ].
	classToRemove ifNotNil: [ classToRemove removeFromSystem ]! !

!DEApplicationDescriptionTest methodsFor: 'running' stamp: 'DiegoLont 8/27/2012 15:22'!
tearDown
	WAAdmin unregister: 'Forum Demo'.
	self removeClass: #FDFileLibrary.
	self removeClass: #FDForumDemoApplication.
	self removeClass: #FDApplicationDescription.
	SystemOrganization removeCategory: 'ForumDemo'.
	SystemOrganization removeCategory: 'ForumDemo-Web'! !

!DEApplicationDescriptionTest methodsFor: 'tests' stamp: 'DiegoLont 8/27/2012 13:43'!
testNewApplication
	"self assert: (SystemOrganization categoriesMatching: 'ForumDemo') isEmpty."
	DEApplicationDescription newApplication: 'Forum Demo' prefix: 'FD' category: 'ForumDemo'.
	self assert: (Smalltalk at: #FDApplicationDescription ifAbsent: [ nil ]) notNil.
	self assert: (Smalltalk at: #FDFileLibrary ifAbsent: [ nil ]) notNil.
	self assert: (Smalltalk at: #FDForumDemoApplication ifAbsent: [ nil ]) notNil.
	WADispatcher default handlerAt: 'Forum Demo' ifAbsent: [ self assert: false ].
	self assert: ((Smalltalk at: #FDForumDemoApplication) new title) equals: 'Forum Demo'.
	self assert: (Smalltalk at: #FDForumDemoApplication) canBeRoot
! !

TestCase subclass: #DEDomainClassDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Framework-Test'!

!DEDomainClassDescriptionTest methodsFor: 'running' stamp: 'DiegoLont 8/27/2012 15:21'!
removeClass: aClassSymbol
	| classToRemove |
	classToRemove := Smalltalk at: aClassSymbol ifAbsent: [ nil ].
	classToRemove ifNotNil: [ classToRemove removeFromSystem ]! !

!DEDomainClassDescriptionTest methodsFor: 'running' stamp: 'DiegoLont 8/27/2012 15:12'!
setUp
	DEApplicationDescription newApplication: 'Forum Demo' prefix: 'FD' category: 'ForumDemo'! !

!DEDomainClassDescriptionTest methodsFor: 'running' stamp: 'DiegoLont 8/29/2012 10:33'!
tearDown
	WAAdmin unregister: 'Forum Demo'.
	self removeClass: #FDFileLibrary.
	self removeClass: #FDModel.
	self removeClass: #FDAuthor.
	self removeClass: #FDQuestion.
	self removeClass: #FDTag.
	self removeClass: #FDForumDemoApplication.
	self removeClass: #FDApplicationDescription.
	SystemOrganization removeCategory: 'ForumDemo'.
	SystemOrganization removeCategory: 'ForumDemo-Web'.
	SystemOrganization removeCategory: 'ForumDemo-Model'.! !

!DEDomainClassDescriptionTest methodsFor: 'tests' stamp: 'DiegoLont 8/29/2012 10:37'!
testAddCollectionToDomainClass
	((Smalltalk at: #FDApplicationDescription) addDomainClass: 'Model')
		beRoot;
		addCollection: 'authors' of: 'Author';
		addCollection: 'questions' of: 'Question';
		addCollection: 'tags' of: 'Tag'.
	self assert: (Smalltalk keys includesAllOf: #( FDModel FDAuthor FDQuestion FDTag )).
	self assert: ((Smalltalk at: #FDModel) default respondsTo: #authors).
	self assert: ((Smalltalk at: #FDModel) default authors isEmpty).! !

!DEDomainClassDescriptionTest methodsFor: 'tests' stamp: 'DiegoLont 8/29/2012 10:24'!
testAddDomainClass
	((Smalltalk at: #FDApplicationDescription) addDomainClass: 'Model').
	self assert: (Smalltalk includesKey: #FDModel)! !

!DEDomainClassDescriptionTest methodsFor: 'tests' stamp: 'DiegoLont 8/29/2012 10:29'!
testRootDomainClass
	((Smalltalk at: #FDApplicationDescription) addDomainClass: 'Model')
		beRoot.
	(Smalltalk at: #FDModel ifAbsent: [ self assert: false ]).
	self assert: ((Smalltalk at: #FDModel) respondsTo: #default).
	self assert: ((Smalltalk at: #FDModel) default isKindOf: (Smalltalk at: #FDModel))! !
